// VB addresses and tools
// Virtual-E (c) 2000 <virtuale98@yahoo.com>
// Coded by Alberto Covarrubias
// Modified by Amos Bieler

#ifndef _VBADDR_H_
#define _VBADDR_H_

#define VIP_REGS(x)	*((PHWORD)(0x0005F800 + x))

/****** VIP Register Mnemonics ******/
#define	INTPND		0x00	// Interrupt Pending
#define	INTENB		0x02	// Interrupt Enabled Flag
#define	INTCLR		0x04	// Clear the bits in INTPND
#define	DPSTTS		0x20	// Display Status
#define	DPCTRL		0x22	// Display Control

#define	BRTA		0x24	// Color 1 Brightness (0-80 [0-100?])
#define	BRTB		0x26	// Color 2 Brightness (0-80 [0-100?])
#define	BRTC		0x28	// Color 3 Brightness = A + B + C

#define	REST		0x2A	// Counter, reset with 0x0000?
#define	FRMCYC		0x2E	// Repeat/G_CLK?
#define	CTA			0x30	// Column Table Address, R/L (Read Only?)
#define	XPSTTS		0x40	// XP Status (?)
#define	XPCTRL		0x42	// XP Control (?)
#define	VER			0x44	// Hardware Version Number (Static?)

#define	SPT0		0x48	// Pointers to the 4 OBJ groups in OAM
#define	SPT1		0x4A
#define	SPT2		0x4C
#define	SPT3		0x4E

#define	GPLT0		0x60	// 4 four-color (2-bit) palettes for BGMaps
#define	GPLT1		0x62
#define	GPLT2		0x64
#define	GPLT3		0x66

#define	JPLT0		0x68	// 4 four-color (2-bit) palettes for OBJs
#define	JPLT1		0x6A
#define	JPLT2		0x6C
#define	JPLT3		0x6E

#define	BKCOL		0x70	// The screen is cleared to BKCOL before rendering.
							// 0: Black, 1-3: BRTA-BRTC

#define SND_REGS(x)	*((PBYTE)(0x01000000 + x))

#define HW_REGS(x)	*((PBYTE)(0x02000000 + x))

/****** Hardware Register Mnemonics ******/
#define	LC1		0x00		// Link Port Control 1
#define	LC2		0x04		// Link Port Control 2
#define LPT		0x08		// Link Port Transmit
#define	LPR		0x0C		// Link Port Receive
#define	KLB		0x10		// Keypad Low Byte
#define	KHB		0x14		// Keypad High Byte
#define	TLB		0x18		// Timer Low Byte
#define	THB		0x1C		// Timer High Byte
#define	TCR		0x20		// Timer Control Register
#define	WCR		0x24		// Wait-state Control Register
#define	KCR		0x28		// Keypad (controller) Control Register

/****** Handy Video RAM Locations ******/
#define	CharSeg0	0x6000
#define	CharSeg1	0xE000
#define	CharSeg2	0x16000
#define	CharSeg3	0x1E000
#define	ObjectSeg	0x3E000
#define	Object(x)	(ObjectSeg+(8*x))
#define BGMap(x)	(0x20000+(0x2000*x))
#define World(x)	(0x3D800+(x*0x20))

#endif
